import CMath
import Foundation

func readNumber(prompt: String) -> Double? {
    print(prompt, terminator: " ")
    
    if let input = readLine(), let number = Double(input) {
        return number
    } else {
        print("ERROR: Input was not a valid number!")
        return nil
    }
}

func main() {
    while true {
        print("""
              Console Calculator -- Operations:
              1 - Addition
              2 - Subtraction
              3 - Multiplication
              4 - Division
              5 - Power
              6 - Square Root
              
              q - Quit the application
              """)
        print("Please enter your choice: ", terminator: "")
        
        if let operation = readLine() {
            if operation.lowercased( ) == "q" {
                break
            }
            
            switch operation {
            case "1":
                if let number1 = readNumber(prompt: "Please enter the first number:"),
                   let number2 = readNumber(prompt: "Please enter the second number:") {
                    let result = add_nums(number1, number2)
                    print("Result: \(result)")
                }
                
            case "2":
                if let number1 = readNumber(prompt: "Please enter the first number:"),
                   let number2 = readNumber(prompt: "Please enter the second number:") {
                    let result = sub_nums(number1, number2)
                    print("Result: \(result)")
                }
                
            case "3":
                if let number1 = readNumber(prompt: "Please enter the first number:"),
                   let number2 = readNumber(prompt: "Please enter the second number:") {
                    let result = mul_nums(number1, number2)
                    print("Result: \(result)")
                }
                
            case "4":
                if let number1 = readNumber(prompt: "Please enter the first number:"),
                   let number2 = readNumber(prompt: "Please enter the second number:") {
                    if number2 == 0 {
                        print("ERROR: Division by zero!")
                        continue
                    }
                    
                    let result = div_nums(number1, number2)
                    print("Result: \(result)")
                }
                
            case "5":
                if let number1 = readNumber(prompt: "Please enter the base:"),
                   let number2 = readNumber(prompt: "Please enter the exponent:") {
                    let result = pow(number1, number2)
                    print("Result: \(result)")
                }
                
            case "6":
                if let number = readNumber(prompt: "Please enter the number to calculate the square root for:") {
                    if number < 0 {
                        print("ERROR: Cannot take the Square Root of a negative number!")
                        continue
                    }
                    
                    let result = sqrt(number)
                    print("Result: \(result)")
                }
                
            default:
                print("ERROR: Invalid operation!")
            }
        } else {
            break
        }
    }
}

main()
